﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Net;
using System.IO;
using System.Text.RegularExpressions;

namespace shopadmin
{
    public class addimage : LeWell.Api.IWebPost
    {
        #region IWebPost 成员

        public string Error
        {
            get { return ""; }
        }

        public bool GetFormHash(string hashUrl, string hashRefer, string user_agent, System.Net.CookieCollection cookies, string hashStart, string hashEnd, ref string result)
        {
            return false;
        }

        public Dictionary<string, string> GetList(string refreshUrl, string refreshRefer, string user_agent, System.Net.CookieCollection cookies, string refreshStart, string refreshEnd, string refreshRegex, ref string html)
        {
            return new Dictionary<string, string>();
        }

        public bool Login(string loginUrl, string loginRefer, string user_agent, string loginImgUrl, Dictionary<string, string> dicPost, string[] failInfos, string[] sucessInfos, ref string errorHtml, System.Net.CookieCollection cookies)
        {
            return false;
        }

        public bool Post(string PostUrl, string PostRefer, string user_agent, System.Net.CookieCollection cookies, List<KeyValuePair<string, string>> dic, Dictionary<string, List<string>> uploadFiles, string[] failInfos, string[] sucessInfos, ref string error, ref string sucess, ref string html)
        {
            try
            {
                string boundary = "------------abc";
                string formdata = "Content-Disposition: form-data; name=\"{0}\"";
                List<Images> images = new List<Images>();

                string host = "";
                CookieContainer cc = new CookieContainer();
                //有图片先上传图片
                if (uploadFiles.Count > 0)
                {
                    string hostpath = PostUrl.Substring(0, PostUrl.LastIndexOf("/", PostUrl.LastIndexOf("?")) + 1);
                    string sess_id = "";
                    foreach (Cookie c in cookies)
                    {
                        if (c.Name == "SHOPEX_SID")
                        {
                            sess_id = c.Value;
                            break;
                        }
                    }
                    if (sess_id == "")
                    {
                        error = "网站没有登录，cookie中没有找到sess_id";
                        return false;
                    }

                    //SHOPEX_SID

                    foreach (KeyValuePair<string, List<string>> item in uploadFiles)
                    {
                        foreach (string s in item.Value)
                        {
                            List<byte[]> lb = new List<byte[]>();
                            StreamReader sr = null;
                            System.IO.Stream sm1 = null;
                            FileStream fs = null;
                            Stream sm2 = null;
                            try
                            {
                                HttpWebRequest request = (HttpWebRequest)HttpWebRequest.Create(hostpath + "index.php?ctl=goods/product&act=newPic&p[0]=&p[1]=add&sess_id=" + sess_id);//&sess_id=ce3567494cad541e4b19afef5f5aef6d
                                request.ContentType = "multipart/form-data; boundary=----------abc";
                                request.UserAgent = "Shockwave Flash";
                                request.Method = "POST";
                                request.Timeout = 60000;
                                host = new Uri(PostUrl).Host;
                                foreach (Cookie c in cookies)
                                {
                                    if (string.IsNullOrEmpty(c.Domain) || host.EndsWith(c.Domain.Trim('.')))
                                    {
                                        Cookie ck = new Cookie(c.Name, c.Value, "/", host);
                                        cc.Add(ck);
                                    }
                                }
                                request.CookieContainer = cc;

                                //添加数据
                                string fn = Path.GetFileName(s);
                                lb.Add(Encoding.UTF8.GetBytes(boundary + "\r\n" + string.Format(formdata, "Filename") + "\r\n\r\n" + fn + "\r\n"));
                                lb.Add(Encoding.UTF8.GetBytes(boundary + "\r\n" + string.Format(formdata, "Filedata") + "; filename=\"" + fn + "\"\r\n" + "Content-Type: application/octet-stream\r\n\r\n"));

                                fs = new FileStream(s, System.IO.FileMode.Open);
                                byte[] buffer = new byte[fs.Length];
                                fs.Read(buffer, 0, (int)fs.Length);
                                lb.Add(buffer);

                                lb.Add(Encoding.UTF8.GetBytes("\r\n" + boundary + "\r\n" + string.Format(formdata, "Upload") + "\r\n\r\n" + "Submit Query\r\n" + boundary + "--"));

                                //合并所有数据
                                byte[] b = getbyte(lb);
                                request.ContentLength = b.Length;
                                sm1 = request.GetRequestStream();
                                sm1.Write(b, 0, b.Length);

                                //获取响应数据
                                HttpWebResponse response = (HttpWebResponse)request.GetResponse();
                                sm2 = response.GetResponseStream();
                                sr = new StreamReader(sm2);
                                string imageid = sr.ReadToEnd();

                                //获取图片id
                                Match m = Regex.Match(imageid, "pic\\.setDefault\\('(\\d+)'[\\s\\S]*?soucre=\"(.*?)\"");

                                if (m.Success)
                                {
                                    Images ups = new Images(m.Result("$1"), m.Result("$2"), fn, s);
                                    images.Add(ups);
                                }
                                if (fs != null) fs.Close();
                                if (sm1 != null) sm1.Close();
                                if (sm2 != null) sm2.Close();
                                if (sr != null) sr.Close();

                                if (!m.Success)
                                {
                                    error = imageid;
                                    return false;
                                }
                            }
                            catch (Exception e)
                            {
                                if (fs != null) fs.Close();
                                if (sm1 != null) sm1.Close();
                                if (sm2 != null) sm2.Close();
                                if (sr != null) sr.Close();
                                error = e.Message;
                                return false;
                            }
                        }
                    }
                }
                HttpWebRequest request1 = (HttpWebRequest)HttpWebRequest.Create(PostUrl);
                request1.Timeout = 60000;
                request1.ContentType = "application/x-www-form-urlencoded";
                request1.UserAgent = user_agent;
                request1.Method = "POST";
                host = new Uri(PostUrl).Host;
                cc = new CookieContainer();
                foreach (Cookie c in cookies)
                {
                    if (string.IsNullOrEmpty(c.Domain) || host.EndsWith(c.Domain.Trim('.')))
                    {
                        Cookie ck = new Cookie(c.Name, c.Value, "/", host);
                        cc.Add(ck);
                    }
                }
                request1.CookieContainer = cc;
                request1.Referer = PostRefer;
                StringBuilder sb = new StringBuilder();
                bool hasimage_default = false;
                foreach (KeyValuePair<string, string> item in dic)
                {
                    if (item.Key == "image_default" && images.Count > 0)
                    {
                        sb.Append(item.Key + "=" + images[0] + "&");
                        hasimage_default = true;
                    }
                    else if (item.Key == "goods[intro]" && images.Count > 0)
                    {
                        string content = item.Value;
                        foreach (Images kv in images)
                        {
                            int pos = content.IndexOf(kv.FileName);
                            int start = -1;
                            if (pos > 0)
                            {
                                for (int i = pos; i > 0; i--)
                                {
                                    string douhao = content[i].ToString();
                                    if (douhao == "'" || douhao == "\"")
                                    {
                                        start = i;
                                        break;
                                    }
                                }
                                if (start > -1)
                                {
                                    string replace = content.Substring(start + 1, pos - start + kv.FileName.Length - 1);
                                    content = content.Replace(replace, "home/upload/" + kv.Src);
                                }
                            }
                        }
                        sb.Append(item.Key + "=" + System.Web.HttpUtility.UrlEncode(content, System.Text.Encoding.UTF8) + "&");
                    }
                    else
                        sb.Append(item.Key + "=" + System.Web.HttpUtility.UrlEncode(item.Value, System.Text.Encoding.UTF8) + "&");
                }
                if (!hasimage_default && images.Count > 0) sb.Append("image_default=" + images[0] + "&");

              //编辑后就有这个了  goods[goods_id]=1684&goods[old_marketable]=true&goods[udfimg]=false&goods[db_thumbnail_pic]=images/goods/20120229/ef817c6b9e3cfc81.jpg|/goods/20120229/ef817c6b9e3cfc81.jpg|fs_storage&goods[db_small_pic]=images/goods/20120229/a960963bfcb54570.jpg|/goods/20120229/a960963bfcb54570.jpg|fs_storage&goods[db_big_pic]=images/goods/20120229/3d816eb12a8b713e.jpg|/goods/20120229/3d816eb12a8b713e.jpg|fs_storage&image_default=5099


                //有图片时加上图片参数
                foreach (Images item in images)
                {
                    sb.Append("goods[image_file][]=" + item.ImageId + "&");
                }

                byte[] bb = Encoding.UTF8.GetBytes(sb.ToString().TrimEnd('&'));
                request1.ContentLength = bb.Length;
                Stream sm3 = request1.GetRequestStream();
                sm3.Write(bb, 0, bb.Length);
                HttpWebResponse response1 = (HttpWebResponse)request1.GetResponse();
                Stream sm4 = response1.GetResponseStream();
                StreamReader sr1 = new StreamReader(sm4);
                html = sr1.ReadToEnd();
                if (sm3 != null) sm3.Close();
                if (sm4 != null) sm4.Close();
                if (sr1 != null) sr1.Close();

                if (sucessInfos != null)
                    foreach (string suc in sucessInfos)
                    {
                        if (html.Contains(suc))
                        {
                            sucess = suc;
                            return true;
                        }
                    }
                if (failInfos != null)
                    foreach (string fal in failInfos)
                    {
                        if (html.Contains(fal))
                        {
                            return false;
                        }
                    }
            }
            catch (Exception gg)
            {
                error = gg.Message;
            }

            return false;
        }

        public bool UseGetFormHash
        {
            get { return false; }
        }

        public bool UseGetList
        {
            get { return false; }
        }

        public bool UseLogin
        {
            get { return false; }
        }

        public bool UsePost
        {
            get { return true; }
        }

        #endregion

        #region ICloneable 成员

        public object Clone()
        {
            return null;
        }

        #endregion

        #region IDisposable 成员

        public void Dispose()
        {

        }

        #endregion

        private byte[] getbyte(List<byte[]> lb)
        {
            int len = 0;
            int index = 0;
            foreach (byte[] item in lb)
            {
                len += item.Length;
            }
            byte[] b = new byte[len];
            foreach (byte[] item in lb)
            {
                item.CopyTo(b, index);
                index += item.Length;
            }
            return b;
        }

        public struct Images
        {
            public Images(string imageid, string src, string filename, string filepath)
            {
                this.ImageId = imageid;
                this.Src = src;
                this.FileName = filename;
                this.FilePath = filepath;
            }
            public string ImageId, Src, FileName, FilePath;
        }
    }
}
